#!/bin/bash

KEYS=(
	"/apps/panel/global/locked_down"
	"/apps/panel/global/disable_force_quit"
	"/desktop/gnome/lockdown/disable_printing"
	"/desktop/gnome/lockdown/disable_print_setup"
	"/desktop/gnome/lockdown/disable_user_switching"
	"/desktop/gnome/lockdown/disable_command_line"
)

KEYS_LABEL=(
	"Verrouiller les tableaux de bord"
	'Désactiver "Forcer à quitter"'
	"Désactiver l'impression"
	"Désactiver la configuration de l'impression"
	"Désactiver le changement rapide d'utilisateur"
	"Désactiver la ligne de commande"
)

###############################################################################
PROG="gconftool-2"
TMP_FILE="/tmp/zenity"
touch $TMP_FILE

function get_boolean_key_value(){
	$PROG --direct --config-source xml:readwrite:$HOME/.gconf.xml.mandatory --get $1
}

function set_gconf_boolean(){
	$PROG --direct --config-source xml:readwrite:$HOME/.gconf.xml.mandatory --type boolean --set $1 $2
}

for k in ${!KEYS[*]};do
	val=`get_boolean_key_value ${KEYS[$k]}`
	echo ${KEYS[$k]}" "$val
	echo "$val" >> $TMP_FILE
	echo "${KEYS[$k]}" >> $TMP_FILE 
	echo "${KEYS_LABEL[$k]}" >> $TMP_FILE
done

ZEN=$(zenity --title="Clefs mandataires" --list --text="Paramètres obligatoires" --checklist --separator " " --multiple --column="Verrouillées" --column="Mandataires" --column="Préferences" --hide-column="2" --print-column="2" < "$TMP_FILE")

if [ $? != 0 ];then
	echo "Annulation par l'utilisateur"
	rm $TMP_FILE
	exit 
fi

for i in $ZEN;do
	for k in ${!KEYS[*]};do
		if [ ${KEYS[$k]} == $i ];then
			set_gconf_boolean $i TRUE
			unset KEYS[$k]
		fi
	done
done

for k in ${KEYS[*]};do
	set_gconf_boolean $k FALSE
done
rm $TMP_FILE

