#!/usr/bin/env python

import logging, os, unicodedata, sys, pwd
import js, ini
import traceback
import background
#from printers import install_printers
import esu
from replace_lin_vars import convert

os_type = "Lin22"

def create_rep(rep):
    try:
        if not os.path.isdir(rep): os.makedirs(rep)
    except Exception, e:
        if type(rep) == unicode:
            rep = unicodedata.normalize("NFKD", rep).encode("ascii", "ignore" )
        logging.error('Erreur de creation du repertoire "%s" %s'%(rep, e))
        logging.debug('Erreur %s'%traceback.format_exc())

def set_background(sid, user_dict):
#    outbg = os.path.join(wa.GetTempPath(), 'cliscribe_bg.bmp')
    outbg = '$HOME/.cliscribe_bg.png'
    outbg = os.path.expandvars(os.path.expanduser(outbg))
    if not os.path.isfile(outbg): file(outbg, 'w').write('')
    #fixme
    #if option.get_esu_show_username() != 1:
    if 1 != 1:
        logging.debug("Application du fond d'ecran par defaut")
        background.del_backgrnd(outbg)
#        background.apply_wallpaper(sid)
        return
#    logging.debug('Option esu_show_username=%s'%option.get_esu_show_username())
    logging.info("Generation du fond d'ecran personnalise")
    message = user_dict['bckgrnd_msg'].splitlines()
    try: background.set_backgrnd(sid, message)
    except:
        logging.error("Echec de la mise en place du fond d'ecran")
        logging.debug('Erreur %s'%traceback.format_exc())

def set_js(js_list):
    if len(js_list) == 0:
        logging.debug('Liste JS vide : %s'%js_list)
        return
    try:
        for fich, var, value, typ in js_list:
            if value == 'IGNORE': continue
            rep = os.path.dirname(fich)
            logging.debug('JS : %s'%([fich, var, value, typ]))
            create_rep(rep)
            js.set_option(fich, var, value, typ)
    except Exception, e:
        logging.error("erreur set_js")

def set_ini(ini_list):
    if len(ini_list) == 0:
        logging.debug('Liste INI vide : %s'%ini_list)
        return
    try:
        for fich, sect, var, value, typ in ini_list:
            if value == 'IGNORE': continue
            rep = os.path.dirname(fich)
            logging.debug('INI : %s'%([fich, sect, var, value, typ]))
            rep = os.path.dirname(fich)
            rep = os.path.dirname(fich)
            create_rep(rep)
            ini.set_option(fich, sect, var, value, typ)
    except Exception, e:
        logging.error('%s'%e)
        logging.debug('Erreur %s'%traceback.format_exc())

esu_dict = esu.ESU()._esu_dict
home = pwd.getpwuid(os.getuid())[5]
vard={}
vard['AppData']=home
vard['PERSONAL']=home
vard['USERNAME']=esu_dict['esu_dict']['USERNAME']
vard['USERLNAME']=esu_dict['esu_dict']['USERLNAME']
vard['COMPUTERNAME']=esu_dict['esu_dict']['COMPUTERNAME']
vard['USERPROFILE']=home
vard['windir']=home
vard['ESU_GM']=esu_dict['esu_dict']['ESU_GM']
vard['ESU_GU']=esu_dict['esu_dict']['ESU_GU']


user_dict=convert(esu_dict['user_dict'], vard)
set_background('sid', user_dict)
set_ini(user_dict['ini'])
set_js(user_dict['js'])
#os.system('sudo /usr/share/client-eole/admin_local.py')
