#!/bin/bash

EchoError(){
    echo $1
    exit 1
}

ACT=$1
NAMEUSER=$2
FILEGROUP=/etc/sudoers

if [ ! $# = 2 ]; then
    EchoError "usage: $0 [add|remove] name"
fi

add_group(){
    grep -q "^$NAMEUSER " $FILEGROUP
    [ $? = 1 ] && echo "$NAMEUSER ALL=(ALL) ALL" >> $FILEGROUP
}
remove_group(){
    grep -q "^$NAMEUSER " $FILEGROUP
    [ $? = 0 ] && sed -i "/$NAMEUSER/d" $FILEGROUP
}
# test username
echo "$NAMEUSER" | grep -qE "[^[:alnum:]\.-]"
[ $? = 0 ] && EchoError "not a valide user"
id $NAMEUSER > /dev/null 2>&1
[ $? = 1 ] && EchoError "unknown user"

# add/remove
if [ "$ACT" = "add" ]; then
    add_group
elif [ "$ACT" = "remove" ]; then
    remove_group
else
    EchoError "unknown option"
fi

exit 0
